;+===================== SmallInctal =======================+
;|      : 06.06.2010                                 |
;+=========================================================+
EnableExplicit

;{ 
#WIN_WIDTH = 500
#PROG_NAME = "LPlayer"
#PROG_COMENT = "MediaPlayer"
#PROG_SIZE = 100
#CH$ = Chr(151) +Chr(151) +Chr(151)
#AP$ = Chr(34)
#LE$ = Chr(171)
#RI$ = Chr(187)
;}

;{  
Enumeration 0
 #wMain; Window
 #iCont; Image
 #iLoloPure
 #bStart; Button
 #bQuit
 #bOpen
 #sPath; String
 #tStr1; Text
 #tStr2
 #tStr3
 #tStr4
 #tStr5
 #tStr6
 #tStr7
EndEnumeration
;}

;{ 
Structure sSYSTEM
 CurHand.i
 Version.s
 ExePath.s
 DocPath.s
 ProgPath.s
EndStructure
Global Sys.sSYSTEM
;}

;{  
Declare Initialization()
Declare Finalization()
Declare Activate()
;}


Initialization()
Activate()
End

 
Procedure$ GetSystemFolder(Value)
Protected *Item.ITEMIDLIST = #Null 
Protected$ St = Space(#MAX_PATH) 
 If SHGetSpecialFolderLocation_(0, Value, @*Item) = #NOERROR 
  If SHGetPathFromIDList_(*Item, @St) 
   If Right(St, 1) <> "\" : St +"\" : EndIf 
   ProcedureReturn St 
  EndIf 
 EndIf 
EndProcedure

Procedure.w IsMouseOver(Gadget)
Protected Point.POINT, Rect.RECT
 GetWindowRect_(Gadget, Rect) 
 GetCursorPos_(Point) 
 ProcedureReturn PtInRect_(@Rect, Point\X|(Point\Y <<32)) 
EndProcedure

;{ CreateShortcut
Macro DEFINE_GUID(Name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8)
 CompilerIf Defined(Name, #PB_Variable)
  If SizeOf(Name) = SizeOf(GUID)
   Name\Data1    = l
   Name\Data2    = w1
   Name\Data3    = w2
   Name\Data4[0] = b1
   Name\Data4[1] = b2
   Name\Data4[2] = b3
   Name\Data4[3] = b4
   Name\Data4[4] = b5
   Name\Data4[5] = b6
   Name\Data4[6] = b7
   Name\Data4[7] = b8
  Else : Debug "Error - variable not declared as guid" : EndIf
 CompilerEndIf
EndMacro

Procedure CreateShellLink(Path.s, Link.s, WorkingDir.s = "", Argument.s = "", Description.s =  "", ShowCommand.l = #SW_SHOWNORMAL, HotKey.l = #Null, IconFile.s = "|", IconIndex.l = 0)
Protected psl.IShellLinkW, ppf.IPersistFile, Result
Protected.GUID CLSID_ShellLink, IID_IShellLink, IID_IPersistFile
 DEFINE_GUID(CLSID_ShellLink, $00021401, $0000,$0000, $C0, $00, $00, $00, $00, $00, $00, $46) ; {00021401-0000-0000-C000-000000000046}
 DEFINE_GUID(IID_IShellLink, $000214F9, $0000,$0000, $C0, $00, $00, $00, $00, $00, $00, $46)  ; {000214F9-0000-0000-C000-000000000046}
 DEFINE_GUID(IID_IPersistFile, $0000010B, $0000,$0000, $C0, $00, $00, $00, $00, $00, $00, $46); {0000010b-0000-0000-C000-000000000046}
 If IconFile = "|" : IconFile = Path : EndIf
 If Not WorkingDir : WorkingDir = GetPathPart(Path) : EndIf
 CoInitialize_(0)
 If CoCreateInstance_(@CLSID_ShellLink, 0, 1, @IID_IShellLink, @psl) =  #S_OK
  Set_ShellLink_preferences:
  psl\SetPath(Path)
  psl\SetArguments(Argument)
  psl\SetWorkingDirectory(WorkingDir)
  psl\SetDescription(DESCRIPTION)
  psl\SetShowCmd(ShowCommand)
  psl\SetHotkey(HotKey)
  psl\SetIconLocation(IconFile, IconIndex)
  ShellLink_SAVE:
  If psl\QueryInterface(@IID_IPersistFile, @ppf) = #S_OK
   ppf\Save(Link, #True)
   Result = 1
   ppf\Release()
  EndIf
  psl\Release()
 EndIf
 CoUninitialize_()
 ProcedureReturn Result
 EndProcedure
 ;}
 
Procedure NewPath()
Protected$ Path
 Path = PathRequester("   " +#PROG_NAME +":", Sys\ProgPath)
 If Path = "" : ProcedureReturn : EndIf
 Sys\ProgPath = Path
 SetGadgetText(#sPath, Path +#PROG_NAME +"\")
EndProcedure

Procedure GetMemory(Value1, Value2, Path.s = "C:\")
Structure sInt64
 Long1.l
 Long2.l
EndStructure
Protected.sInt64 BytesFree, TotalBytes, TotalFree
 SetErrorMode_(#SEM_FAILCRITICALERRORS)
 If GetDiskFreeSpaceEx_(@Path, BytesFree, TotalBytes, TotalFree) = 0 : MessageRequester("", " !", 0)  : End : EndIf
 SetErrorMode_(0)
 PokeL(Value1, ((TotalBytes\Long1 >>20) &$FFF) |(TotalBytes\Long2 <<12))
 PokeL(Value2, ((TotalFree\Long1 >>20) &$FFF) |(TotalFree\Long2 <<12))
EndProcedure

Procedure.a QuitSetup()
Protected.A Rez
 Rez = MessageRequester(" " +#PROG_NAME, "     " +Chr(13) +#PROG_NAME +"?", #MB_YESNO|#MB_ICONQUESTION)
 If Rez = #IDYES : ProcedureReturn #True : Else : ProcedureReturn #False : EndIf
EndProcedure

Procedure ExtractFiles()
Protected$ St = Sys\ProgPath +#PROG_NAME +"\"
 CreateDirectory(St)
 If CreateFile(0, St +#PROG_NAME +".exe")
  WriteData(0, ?Exe, ?Unis -?Exe)
  CloseFile(0)
  CreateFile(0, St +"uninst.exe")
  WriteData(0, ?Unis, ?EndExe -?Unis)
  CloseFile(0)
  CreateFile(0, St +"License.txt")
  WriteData(0, ?Res_2, ?Exe -?Res_2)
  CloseFile(0)
  CreateDirectory(GetSystemFolder(11) +#PROG_NAME +"\")
  CreateShellLink(St +#PROG_NAME +".exe", GetSystemFolder(11) +#PROG_NAME +"\" +#PROG_NAME +".lnk", "", #PROG_COMENT, St, 0, 0, St +#PROG_NAME +".exe", 0)
  CreateShellLink(St +#PROG_NAME +".exe", GetSystemFolder(0) +#PROG_NAME +".lnk", "", #PROG_COMENT, St, 0, 0, St +#PROG_NAME +".exe", 0)
  CreateShellLink(St +"uninst.exe", GetSystemFolder(11) +#PROG_NAME +"\" +"uninst.lnk", "", "Uninstall", St, 0, 0, St +"uninst.exe", 0)
  CreateFile(0, St +"uninst.dat")
  WriteStringN(0, "InstalMaker Uninstall Log")
  WriteStringN(0, St +#PROG_NAME +".exe")
  WriteStringN(0, St +"License.txt")
  WriteStringN(0, GetSystemFolder(11) +#PROG_NAME +"\" +#PROG_NAME +".lnk")
  WriteStringN(0, GetSystemFolder(0) +#PROG_NAME +".lnk")
  WriteStringN(0, St +"uninst.dat")
  CloseFile(0)
 EndIf
EndProcedure


Procedure FormCreate()
Protected i = CreateSemaphore_(#Null, 0, 1, GetProgramName()), Free
 If i <> 0 And GetLastError_() = #ERROR_ALREADY_EXISTS : CloseHandle_(i) : End : EndIf
 If Not OpenWindow(#wMain, 0, 0, #WIN_WIDTH, 356, " " +#CH$ +#PROG_NAME +Sys\Version, #PB_Window_SystemMenu|#PB_Window_MinimizeGadget|#PB_Window_TitleBar|#PB_Window_ScreenCentered|#PB_Window_Invisible) : ProcedureReturn : EndIf
 i = ContainerGadget(#PB_Any, 0, 0, #WIN_WIDTH, 61, #PB_Container_BorderLess)
 SetGadgetColor(i, #PB_Gadget_BackColor, $FFFFFF)
 TextGadget(#tStr1, 30, 7, 180, 22, "  ")
 If LoadFont(0, "Courier New", 10, #PB_Font_Bold|#PB_Font_HighQuality) : SetGadgetFont(#tStr1, FontID(0)) : EndIf
 SetGadgetColor(#tStr1, #PB_Gadget_BackColor, $FFFFFF)
 TextGadget(#tStr2, 45, 30, 330, 20, "     .")
 SetGadgetColor(#tStr2, #PB_Gadget_BackColor, $FFFFFF)
 ImageGadget(#iCont, #WIN_WIDTH -70, 0, 60, 60, CatchImage(500, ?Res_1))
 CloseGadgetList()
 Frame3DGadget(#PB_Any, 0, 62, #WIN_WIDTH, 2, "", #PB_Frame3D_Flat)
 TextGadget(#tStr3, 20, 90, 390, 20, #LE$ +"" +#RI$ +" -      .")
 TextGadget(#tStr4, 20, 120, 400, 20, #LE$ +" " +#RI$ +" -      .")
 Frame3DGadget(#PB_Any, 20, 180, #WIN_WIDTH -40, 60, " ")
 StringGadget(#sPath, 30, 205, 350, 20, Sys\ProgPath +#PROG_NAME +"\", #ES_READONLY)
 SetActiveGadget(#sPath)
 SetGadgetColor(#sPath, #PB_Gadget_BackColor, $FFFFFF)
 ButtonGadget(#bOpen, 390, 203, 80, 25, " ")
 TextGadget(#tStr5, 20, 252, 370, 20, "   " +Str(#PROG_SIZE) +"    .") 
 GetMemory(@i, @Free, Sys\ProgPath)
 TextGadget(#tStr6, 20, 274, 180, 20, "   " +Str(Free) +" .")
 TextGadget(#tStr7, 5, 302, #WIN_WIDTH -10, 20, #CH$ +" Copyright " +Chr(169) +" 2010 Lepasa " +#CH$ +#CH$ +#CH$ +#CH$ +#CH$ +#CH$ +#CH$ +#CH$ +#CH$ +#CH$ +#CH$ +#CH$ +#CH$ +#CH$)
 If LoadFont(0, "Courier New", 8, #PB_Font_Bold|#PB_Font_HighQuality) : SetGadgetFont(#tStr7, FontID(0)) : EndIf
 DisableGadget(#tStr7, #True)
 ImageGadget(#iLoloPure, 15, 317, 112, 33, CatchImage(501, ?LPure)) : GadgetToolTip(#iLoloPure, "http://www.purebasic.com/")
 ButtonGadget(#bStart, 320, 321, 80, 25, "")
 ButtonGadget(#bQuit, 410, 321, 80, 25, "")
EndProcedure

Procedure Initialization()
 Sys\CurHand = LoadCursor_(0, #IDC_HAND)
 Sys\Version = " ["
 If Len(Str(Day(#PB_Compiler_Date))) < 2 : Sys\Version = Sys\Version +"0" +Str(Day(#PB_Compiler_Date)) : Else : Sys\Version = Sys\Version +Str(Day(#PB_Compiler_Date)) : EndIf
 Sys\Version = Sys\Version +"."
 If Len(Str(Month(#PB_Compiler_Date))) < 2 : Sys\Version = Sys\Version +"0" +Str(Month(#PB_Compiler_Date)) : Else : Sys\Version = Sys\Version +Str(Month(#PB_Compiler_Date)) : EndIf
 Sys\Version = Sys\Version +"." +Str(Year(#PB_Compiler_Date))
 CompilerIf #PB_Compiler_Processor = #PB_Processor_x64 : Sys\Version = Sys\Version +" (x64)" : CompilerEndIf
 Sys\Version = Sys\Version +"]"
 Sys\ExePath = GetPathPart(ProgramFilename())
 Sys\DocPath = GetSystemFolder(5);  
 Sys\ProgPath = GetSystemFolder(38); Program Files (x86)
 FormCreate()
 SetClassLong_(GadgetID(#bQuit), #GCL_HCURSOR, Sys\CurHand)
 HideWindow(#wMain, #False)
EndProcedure

Procedure Finalization()
 DestroyCursor_(Sys\CurHand)
EndProcedure


Procedure Activate()
Protected Quit.a, Event, GadgetID, ActivID, TotalMB, FreeMB, St.s
 Repeat
  Event = WaitWindowEvent(100)
  GadgetID = EventGadget()
  ActivID = GetActiveGadget()
  If ActivID = #sPath : SetActiveGadget(#bOpen) : EndIf
  Select Event
   Case #PB_Event_Gadget
    Select GadgetID
     Case #bStart : ExtractFiles()
      MessageRequester("   " +#PROG_NAME, " " +#PROG_NAME +"  " +Chr(13) +"  .    " +Chr(13) +"  .", #MB_OK|#MB_ICONINFORMATION)
      Quit = #True
     Case #bOpen : NewPath() : GetMemory(@TotalMB, @FreeMB, Sys\ProgPath) : SetGadgetText(#tStr6, "   " +Str(FreeMB) +" ")
     Case #bQuit : Quit = QuitSetup()
    EndSelect
   Case #WM_MOUSEMOVE 
    If IsMouseOver(GadgetID(#iLoloPure)) : SetCursor_(Sys\CurHand) : EndIf
   Case #WM_LBUTTONUP
    If IsMouseOver(GadgetID(#iLoloPure)) : ShellExecute_(0, "open", "http://www.purebasic.com/", 0, 0, #SW_SHOWNORMAL) : EndIf 
   Case #PB_Event_CloseWindow : Quit = QuitSetup()
  EndSelect
 Until Quit
 Finalization()
EndProcedure

;{ 
DataSection
 LPure : IncludeBinary "\LogotipPB.bmp"
 Res_1 : IncludeBinary "\loading.bmp"
 Res_2 : IncludeBinary "\License.txt"
 Data.a 0
 Exe : IncludeBinary "\LPlayer.exe"
 Unis : IncludeBinary "\uninst.exe" : EndExe :
EndDataSection
;}
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 115
; FirstLine = 101
; Folding = ----
; EnableXP
; EnableUser
; UseIcon = \icon.ico
; Executable = SmallInctal.exe
; IncludeVersionInfo
; VersionField0 = 06.07.2010.21
; VersionField2 = Lepasa
; VersionField3 = LPlayer
; VersionField4 = 2.0.1
; VersionField6 = 
; VersionField8 = LPlayer
; VersionField9 = Sashok KAD
; VersionField10 = Lepasa software
; VersionField17 = 0419 Russian