; http://purebasic.info/phpBB2/viewtopic.php?t=1143
IncludeFile "TrayIcon.pbc"

; -------------------------------------------------------------------
; // TRAYICON TEST
; -------------------------------------------------------------------


Enumeration 
 #WIN_MAIN
 #MNU_TRAY
 #MNI_TRAY_1
 #MNI_TRAY_2
 #MNI_TRAY_3
 #BTN_ADD_TRAY
 #BTN_REMOVE_TRAY
 #BTN_SET_TOOLTIP
 #BTN_REMOVE_TOOLTIP
 #BTN_SHOW_BALLOON
 #BTN_SHOW_BALLOON_ICON
 #BTN_REMOVE_BALLOON
 #BTN_CHANGE_ICON
 #BTN_SET_ICON_FROM_RGBA
 #BTN_BLINK_STATUS 
 #BTN_ANIMATION_SHOT
 #BTN_ANIMATION_LOOP
 #BTN_ANIMATION_STOP
 #BTN_HIDE
 #BTN_STATUS
EndEnumeration

Procedure EnableGadgets()
 DisableGadget(#BTN_ADD_TRAY, 1)   
 DisableGadget(#BTN_REMOVE_TRAY, 0)   
 DisableGadget(#BTN_SET_TOOLTIP, 0)   
 DisableGadget(#BTN_REMOVE_TOOLTIP, 0)   
 DisableGadget(#BTN_SHOW_BALLOON, 0)
 DisableGadget(#BTN_SHOW_BALLOON_ICON, 0)
 DisableGadget(#BTN_REMOVE_BALLOON, 0)
 DisableGadget(#BTN_CHANGE_ICON, 0)
 DisableGadget(#BTN_SET_ICON_FROM_RGBA, 0) 
 DisableGadget(#BTN_BLINK_STATUS, 0) 
 DisableGadget(#BTN_ANIMATION_SHOT, 0)
 DisableGadget(#BTN_ANIMATION_LOOP, 0)
 DisableGadget(#BTN_ANIMATION_STOP, 0) 
 DisableGadget(#BTN_HIDE, 0)
 DisableGadget(#BTN_STATUS, 0)
EndProcedure

Procedure DisableGadgets()
 DisableGadget(#BTN_ADD_TRAY, 0)   
 DisableGadget(#BTN_REMOVE_TRAY, 1)
 DisableGadget(#BTN_SET_TOOLTIP, 1)
 DisableGadget(#BTN_REMOVE_TOOLTIP, 1)
 DisableGadget(#BTN_SHOW_BALLOON, 1)
 DisableGadget(#BTN_SHOW_BALLOON_ICON, 1)
 DisableGadget(#BTN_REMOVE_BALLOON, 1)
 DisableGadget(#BTN_CHANGE_ICON, 1)
 DisableGadget(#BTN_SET_ICON_FROM_RGBA, 1) 
 DisableGadget(#BTN_BLINK_STATUS, 1)
 DisableGadget(#BTN_ANIMATION_SHOT, 1)
 DisableGadget(#BTN_ANIMATION_LOOP, 1)
 DisableGadget(#BTN_ANIMATION_STOP, 1)
 DisableGadget(#BTN_HIDE, 1)
 DisableGadget(#BTN_STATUS, 1)  
EndProcedure


; change if it causes conflict with other user messages you are using
#WM_USER_TRAYICON = #WM_USER

Procedure WinMainCallback (hWnd, iMessage, wParam, lParam)
 Protected iResult = #PB_ProcessPureBasicEvents
  
 Select iMessage  
    Case #WM_USER_TRAYICON ; that's it
    
        Select lParam
            Case #WM_LBUTTONDOWN
                Debug "#WM_LBUTTONDOWN"

            Case #WM_LBUTTONDBLCLK
                Debug "#WM_LBUTTONDBLCLK"
         
            Case #WM_RBUTTONDOWN
                Debug "#WM_RBUTTONDOWN"
                DisplayPopupMenu(#MNU_TRAY, WindowID(#WIN_MAIN))                         
         
            Case #WM_MOUSEMOVE
                Debug "#WM_MOUSEMOVE"
         
            Case #NIN_BALLOONSHOW
                Debug "#NIN_BALLOONSHOW"
         
            Case #NIN_BALLOONTIMEOUT
                Debug "#NIN_BALLOONTIMEOUT"
            
            Case #NIN_BALLOONUSERCLICK
                Debug "#NIN_BALLOONUSERCLICK"
         
            Case #NIN_BALLOONHIDE
                Debug "#NIN_BALLOONHIDE"         
        EndSelect
EndSelect
 
  ProcedureReturn iResult 
EndProcedure

Procedure.i CreateImageRGBA()
 ; This proc creates a image to be used as icon for the TrayIcon object
 ; You can draw it at runtime using the PB commands and convert it 
 ; using TrayIcon_GetIconFromRGBA()
 
 ; You must set the alpha channel to 0 where you want the icon to be transparent
 
 Protected nImage
 
 nImage = CreateImage(#PB_Any, 16, 16, 32)
 
 StartDrawing(ImageOutput(nImage))
 
  DrawingMode(#PB_2DDrawing_AlphaChannel)
  Box(0,0,16,16, RGBA(0,0,0,0)) ; background full transparent 
  
  ; now we blend in our picture
  
  DrawingMode(#PB_2DDrawing_AlphaBlend)  
  
  Box(0, 0, 16, 3, RGBA(220,0,0,255))
  Box(0, 6, 16, 3, RGBA(0,0,0,255))
  Box(0,12, 16, 3, RGBA(0,0,220,255))    
  
 StopDrawing()
 
 ProcedureReturn nImage
EndProcedure

Procedure Main()
 Protected iEvent, iNextType, iNextIcon, flgBlinkStatus, flgHideStatus
 Protected nIcon1, nIcon2
 Protected Dim hAnim(3)
 Protected objTray.TrayIcon
 Protected sWinTitle.s, sTitle.s, sText.s
 Protected nImageRGBA, hIconRGBA
 
 sWinTitle = "TrayIcon class - "
 
 CompilerIf (#PB_Compiler_Processor = #PB_Processor_x86)
    sWinTitle + " x86"
 CompilerElse   
    sWinTitle + " x64"
 CompilerEndIf
 
 CompilerIf (#PB_Compiler_Unicode = 1)
    sWinTitle + " (unicode)"
 CompilerElse   
    sWinTitle + " (ascii)"
 CompilerEndIf
 
 If OpenWindow(#WIN_MAIN, 100, 100, 315, 330, sWinTitle, #PB_Window_SystemMenu)

    nIcon1 = CatchImage(#PB_Any, ?icon1)
    nIcon2 = CatchImage(#PB_Any, ?icon2)
          
    hAnim(0) = CatchImage(#PB_Any, ?anim1)
    hAnim(1) = CatchImage(#PB_Any, ?anim2)
    hAnim(2) = CatchImage(#PB_Any, ?anim3)
    hAnim(3) = CatchImage(#PB_Any, ?anim4)
    
    CreatePopupMenu(#MNU_TRAY)    
    MenuItem(#MNI_TRAY_1, "Item 1")
    MenuItem(#MNI_TRAY_2, "Item 2")
    MenuBar()
    MenuItem(#MNI_TRAY_3, "Item 3")

    
    ButtonGadget(#BTN_ADD_TRAY, 5, 10, 150, 30, "Add Tray Icon")
    ButtonGadget(#BTN_REMOVE_TRAY, 5, 50, 150, 30, "Remove Tray Icon")
    ButtonGadget(#BTN_SET_TOOLTIP, 5, 90, 150, 30, "Set tooltip")
    ButtonGadget(#BTN_REMOVE_TOOLTIP, 5, 130, 150, 30, "Remove tooltip")
    ButtonGadget(#BTN_SHOW_BALLOON, 5, 170, 150, 30, "Show balloon")
    ButtonGadget(#BTN_SHOW_BALLOON_ICON, 5, 210, 150, 30, "Show balloon + icon")
    ButtonGadget(#BTN_REMOVE_BALLOON, 5, 250, 150, 30, "Remove balloon")
    ButtonGadget(#BTN_CHANGE_ICON, 5, 290, 150, 30, "Seticon from icon")
    
    ButtonGadget(#BTN_SET_ICON_FROM_RGBA, 160, 10, 150, 30, "Seticon from RGBA")
    ButtonGadget(#BTN_BLINK_STATUS, 160, 50, 150, 30, "Blink status")
    ButtonGadget(#BTN_ANIMATION_SHOT, 160, 90, 150, 30, "Frame animation (2 cycles)")
    ButtonGadget(#BTN_ANIMATION_LOOP, 160, 130, 150, 30, "Frame animation (loop)")
    ButtonGadget(#BTN_ANIMATION_STOP, 160, 170, 150, 30, "Stop animation")
    ButtonGadget(#BTN_HIDE, 160, 210, 150, 30, "Hide/Show") 
    ButtonGadget(#BTN_STATUS, 160, 250, 150, 30, "Status") 
    
    DisableGadgets()
    
    SetWindowCallback(@WinMainCallback(), #WIN_MAIN)
  
    Repeat 
        iEvent = WaitWindowEvent()
        
        Select iEvent
            Case #PB_Event_Gadget
                Select EventGadget()
                    
                    Case #BTN_ADD_TRAY
                        
                        ; TrayIcon_Create() params are as follow:
                        ; parent window, icon's handle, user message number for events, startup hidden status
                        
                        objTray = TrayIcon_Create(WindowID(#WIN_MAIN), ImageID(nIcon1), #WM_USER_TRAYICON, 0)
                           
                        EnableGadgets()
                        iNextIcon = 1
                        flgBlinkStatus = #False                        
                            
                    Case #BTN_REMOVE_TRAY
                        objTray\Destroy() : objTray = #Null
                        
                        DisableGadgets()
                    
                    Case #BTN_SET_TOOLTIP
                        sText = "I'm a simple and humble tooltip ..."
                        
                        objTray\SetTooltip(sText)
                    
                    Case #BTN_SHOW_BALLOON
                        sTitle = "Balloon"
                        sText = "Here is the balloon (line 1)" + Chr(13) 
                        sText + "With two rows of text (line 2)"
                        
                        objTray\ShowBalloon(sTitle, sText)

                    Case #BTN_SHOW_BALLOON_ICON                                            
                        sText = "Here is the balloon (line 1)" + Chr(13) 
                        sText + "With three rows of text (line 2)" + Chr(13) 
                        sText + "Last row (line 3)"
                        
                        Select iNextType
                            Case 0                                                  
                                sTitle = "Balloon with INFO"
                                objTray\ShowBalloon(sTitle, sText, #TRAY_ICON_INFO)
                            Case 1
                                sTitle = "Balloon with ERROR"
                                objTray\ShowBalloon(sTitle, sText, #TRAY_ICON_ERROR)
                            Case 2
                                sTitle = "Balloon with WARNING"
                                objTray\ShowBalloon(sTitle, sText, #TRAY_ICON_WARNING)
                        EndSelect                        
                        
                        iNextType = (iNextType + 1) % 3
                                            
                    Case #BTN_REMOVE_TOOLTIP
                        objTray\RemoveTooltip()
                        
                    Case #BTN_REMOVE_BALLOON    
                        objTray\RemoveBalloon()
                    
                    Case #BTN_CHANGE_ICON
                        Select iNextIcon
                            Case 0                                                                                  
                                objTray\SetIcon(ImageID(nIcon1))
                            Case 1
                                objTray\SetIcon(ImageID(nIcon2))
                        EndSelect

                        iNextIcon = (iNextIcon + 1) % 2
                        
                    Case #BTN_SET_ICON_FROM_RGBA
                        ; dinamically create a PB image in RGBA
                        nImageRGBA = CreateImageRGBA()
                        
                        ; use the support procedure (it would be a "static" procedure in OOP languages)
                        ; to convert the RGBA to ICON
                        
                        DestroyIcon_(hIconRGBA)
                        hIconRGBA = TrayIcon_GetIconFromRGBA(nImageRGBA)
                        
                        ; now use it 
                        objTray\SetIcon (hIconRGBA)
                        
                        ; we can dispose of the original RGBA image
                        FreeImage(nImageRGBA)                        
                    
                    Case #BTN_BLINK_STATUS
                        flgBlinkStatus = ~ objTray\IsBlinking() & 1
                        objTray\Blink(flgBlinkStatus)                                               
                    
                    Case #BTN_ANIMATION_SHOT
                        objTray\SetAnimationFrames(4)
                        objTray\SetAnimationDelay(250)
                         
                        objTray\LoadFrameIcon(0, ImageID(hAnim(0)))
                        objTray\LoadFrameIcon(1, ImageID(hAnim(1)))
                        objTray\LoadFrameIcon(2, ImageID(hAnim(2)))
                        objTray\LoadFrameIcon(3, ImageID(hAnim(3)))
                          
                        objTray\StartAnimation(2)                                               

                    Case #BTN_ANIMATION_LOOP
                        objTray\SetAnimationFrames(4)
                        objTray\SetAnimationDelay(250)
                         
                        objTray\LoadFrameIcon(0, ImageID(hAnim(0)))
                        objTray\LoadFrameIcon(1, ImageID(hAnim(1)))
                        objTray\LoadFrameIcon(2, ImageID(hAnim(2)))
                        objTray\LoadFrameIcon(3, ImageID(hAnim(3)))
                          
                        objTray\StartAnimation(-1)                                                

                    Case #BTN_ANIMATION_STOP
                        objTray\StopAnimation()
                    
                    Case #BTN_HIDE
                        flgHideStatus = ~ objTray\IsHidden() & 1
                        objTray\Hide(flgHideStatus)

                    Case #BTN_STATUS                        
                        Debug "blinking = " + Str(objTray\IsBlinking())
                        Debug "animated = " + Str(objTray\IsAnimated())
                        Debug "hidden   = " + Str(objTray\IsHidden())
                EndSelect
        EndSelect        
    Until iEvent = #PB_Event_CloseWindow
      
 EndIf
 
 If objTray
    objTray\Destroy()
 EndIf
 
EndProcedure

Main()

DataSection
 icon1: IncludeBinary "i1.ico"
 icon2: IncludeBinary "i2.ico"
 anim1: IncludeBinary "spin_1.ico"
 anim2: IncludeBinary "spin_2.ico"
 anim3: IncludeBinary "spin_3.ico"
 anim4: IncludeBinary "spin_4.ico"
EndDataSection

; IDE Options = PureBasic 4.51 (Windows - x86)
; Folding = -
; EnableXP
; EnableUser
; Executable = test.exe
; CPU = 1