
;***********************************************************************************************
            LIST      p=16F628     ;   .
            __CONFIG  03F01H       ; 
                                   ; 
;===============================================================================================
;     . 
;===============================================================================================

OptionR     equ        01h         ; Option - 1.
pcl         equ        02h         ;
Status      equ        03h         ; Status
PortA       equ        05h         ;  A. 
TrisA       equ        05h         ; Tris A - 1.
PortB       equ        06h         ;  B.
TrisB       equ        06h         ; Tris B - 1.
IntCon      equ        0Bh         ; IntCon.
PIR1        equ        0Ch         ;      
PIE1        equ        0CH         ;       
PCON        equ        0EH         ; 
T1CON       equ        10h         ; T1CON.           TMR1.
T2CON       equ        12h         ; T2CON.           TMR2.
CCP1CON     equ        17h         ; CCP1CON.         CCP.
RCSTA       equ        18h         ;      USART.
TXSTA       equ        18H         ;      USART.
SPBRG       equ        19H         ;    USART.
TXREG       equ        19H         ;    USART.
RCREG       equ        1AH         ;    USART.
VRCON       equ        1Fh         ; VRCON - 1.    .
CMCON       equ        1Fh         ; CMCON.           .

;===============================================================================================
;       .
;===============================================================================================

p_w         equ        70h
p_stat      equ        71h
temp        equ        72h
flags       equ        73h
ind1        equ        74h
ind2        equ        75h
ind3        equ        76h
p_ch        equ        77h
time1       equ        78h
time2       equ        79h
temp_ind1   equ        7ah
temp_ind2   equ        7bh
temp_ind3   equ        7ch
i_temp      equ        7dh

;===============================================================================================
;   .
;===============================================================================================

RP0         equ        5
RP1         equ        6
W           equ        0
F           equ        1
Z           equ        2
C           equ        0
TXIF        equ        4           ;     USART.
;===============================================================================================

            org        0           ;    
            goto    Start          ;   Start.

;***********************************************************************************************
;     TMR0
;===============================================================================================

            org        4
            movwf      p_w         ;  
            swapf      Status,W    ; W  Status 
            movwf      p_stat      ;   .
            bcf        Status,RP1  ;   .
            bcf        Status,RP0
            incfsz     time1
            goto       i_m1
            incfsz     time2
i_m1        decf       p_ch,F
            bcf        PortA,0         
            bcf        PortA,1
            bcf        PortA,2
            movf       p_ch,W
            andlw      b'00000011'
            addwf      pcl,F
            goto       i_ind1
            goto       i_ind2
            goto       i_ind3
            goto       exit
;                                        () .
i_ind3      movf       ind3,F         ; ,   "ind3" ?
            btfsc      Status,Z
            goto       exit           ;  ,     .
            movf       ind3,W
            call       dec_7
            movwf      PortB
            bsf        PortA,2        ;    .
            goto       exit
;                                         .
i_ind2      movf       ind2,F         ; ,   "ind2" ?
            btfsc      Status,Z
            goto       exit           ;  ,     .
i_i2        movf       ind2,W
            call       dec_7          ;       
            movwf      PortB
            bsf        PortA,1        ;    .
            goto       exit
;                                         .
i_ind1      movf       ind1,W
            call       dec_7          ;      
            movwf      PortB
            bsf        PortA,0
exit        bcf        IntCon,2       ;   T0IF (   TMR0)
            swapf      p_stat,W       ;   Status  W.
            movwf      Status
            swapf      p_w,F
            swapf      p_w,W
            retfie                    ;    .

dec_7       call       dec_7_1
            movwf      i_temp      
            btfss      i_temp,2       ;  . ,   . "" HG1.
            goto       d_1
            bsf        PortA,3
            return
d_1         bcf        PortA,3
            return

dec_7_1     andlw      b'00001111'
            addwf      pcl,F
            retlw      b'10000010'
            retlw      b'11110110'
            retlw      b'01001010'
            retlw      b'01100010'
            retlw      b'00110110'
            retlw      b'00100011'
            retlw      b'00000011'
            retlw      b'11110010'
            retlw      b'00000010'
            retlw      b'00100010'
            retlw      b'11111111'
            retlw      b'11111111'
            retlw      b'11111111'
            retlw      b'11111111'
            retlw      b'11111111'
            retlw      b'11111111'
            retlw      b'11111111'



;***********************************************************************************************
;  
;===============================================================================================

Start       bsf        Status,RP0  ; "" ""    
            bcf        Status,RP1  ; 1- .
            movlw      b'10000011'
            movwf      OptionR
            clrf       VRCON       ;    .
            movlw      b'11110000'
            movwf      TrisA       
            movlw      b'00000110'
            movwf      TrisB       
            movlw      b'00100110' 
            movwf      TXSTA       ;   USART.
            movlw      d'25'        
            movwf      SPBRG       ;     9600 /.
            movlw      b'00000000'
            movwf      PIE1        
            bcf        Status,RP0  ;  0- .
            movlw      .07          
            movwf      CMCON       ;  .
            clrf       T1CON       ;   TMR1.
            clrf       T2CON       ;   TMR2.
            clrf       CCP1CON     ;   CCP.
            clrf       flags
            movlw      b'10110000'
            movwf      RCSTA       ;   USART.
            movlw      b'10100000'
            movwf      IntCon      ;    .
            clrf       ind1
            clrf       ind2
            clrf       ind3

;***********************************************************************************************
;   
;===============================================================================================
m1          btfsc      PIR1,5         ;    "rx"      
            call       rx
            call       Key
            goto       m1
;--------------------------------------------------------------------------------------
; .
;--------------------------------------------------------------------------------------
;
;                                            .
rx          movf       RCREG,W        ;   .
            movwf      temp
            call       convert        ; - .
            movf       temp_ind1,W    ;   "ind1"  "ind2"  
            movwf      ind1
            movf       temp_ind2,W
            movwf      ind2
            movf       temp_ind3,W
            movwf      ind3
            bcf        PIR1,5
            bsf        RCSTA,5
            bcf        RCSTA,2
            bcf        RCSTA,1
            return

;                                        - .
convert     clrf       temp_ind2
            clrf       temp_ind3
	    movf       temp,0
	    movwf      temp_ind1
b_2	    movlw      D'10'
	    subwf      temp_ind1,W
	    btfss      Status,C
	    goto       b_1
	    movwf      temp_ind1
	    incf       temp_ind2,F
	    goto       b_2

b_1	    movlw      d'10'
	    subwf      temp_ind2,W
	    btfss      Status,C
	    goto       b_3
            movwf      temp_ind2 
            incf       temp_ind3,F
	    goto       b_1 
b_3    
	    return

Key         btfsc      PortA,4
            return
            movf       temp,W
            movwf      TXREG       ;     .
            btfss      PIR1,TXIF   ;     ?
            goto       $-1    
            btfsc      PortA,4
            return     
            goto       $-2
;***********************************************************************************************
            end                     ;  
